# Knil 🔗

[![Travis CI](https://travis-ci.org/ethanhuang13/knil.svg?branch=master)](https://travis-ci.org/ethanhuang13/knil)
![GitHub release](https://img.shields.io/github/release/ethanhuang13/knil.svg)
![GitHub top language](https://img.shields.io/github/languages/top/ethanhuang13/knil.svg)
![](https://img.shields.io/badge/Platform-iOS%209.0%2B-lightgrey.svg)
[![License](https://img.shields.io/github/license/ethanhuang13/knil.svg)](https://github.com/ethanhuang13/knil/blob/master/LICENSE)
[![Twitter](https://img.shields.io/badge/Twitter-%40ethanhuang13-blue.svg)](https://twitter.com/ethanhuang13)
[![Donate](https://img.shields.io/badge/Donate-PayPal-green.svg)](https://paypal.me/ethanhuang13)

[![](App_Store_Badge.svg)](https://itunes.apple.com/us/app/knil-universal-link-testing/id1195310358?l=zh&ls=1&mt=8&ct=README)

Knil made Universal Links testing easier. It fetches and parses apple-app-site-association file for you to quickly check whether Universal Links are working.

## Demo

Add websites, download related apps, test Universal Links, and customize test links.

![Demo of user add IMDb to Knil and test its Universal Links.](demo.gif)

## Features

| | Features |
| --- | --- |
| 😇 | Open source iOS project written in Swift 5 |
| 📲 | Fetch and parse apple-app-site-association(AASA) files |
| 💡 | App Store links and metadata |
| 🚀 | List all Universal Link paths. One-tap to test! |
| 🛠️ | Customize test links |
| 🤝 | Link to other validation tools like Branch.io's [AASA Validator](https://branch.io/resources/aasa-validator/) or Apple's [App Search API Validation Tool](https://search.developer.apple.com/appsearch-validation-tool/) | 
| 🆓 | Free without ads |
| 🚫 | No third-party tracking or analytics |

## Naming
```
"knil" == "link".reversed()
```

## Install

[![](App_Store_Badge.svg)](https://itunes.apple.com/us/app/knil-universal-link-testing/id1195310358?l=zh&ls=1&mt=8&ct=README)

Download the official release version from [App Store](https://itunes.apple.com/us/app/knil-universal-link-testing/id1195310358?l=zh&ls=1&mt=8&ct=README).

Or, you can install this open source app with the following steps:

1. Clone the repo on [GitHub](https://github.com/ethanhuang13/knil)
2. Open the project with Xcode 10.2 or above
3. Change bundle ID to something like `com.yourcompany.Knil`
4. Build and run on your iOS devices

## Contribution

- Feedback and [issues](https://github.com/ethanhuang13/knil/issues/new) are welcome.
